minor bug fix
[distro-setup] / brc2
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6
7 # * settings
8
9 HISTFILE=$HOME/.bh
10
11 source /a/bin/distro-setup/path-add-function
12 path-add /a/exe
13 # add this with absolute paths as needed for better security
14 #path-add --end /path/to/node_modules/.bin
15
16 # pip3 --user things go here:
17 path-add --end ~/.local/bin
18 path-add --ifexists --end /a/work/libremanage
19 path-add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
20 path-add --ifexists --end /a/opt/scancode-toolkit-3.0.2
21
22 export WCDHOME=/a
23
24
25 # * include files
26
27 # generated instead of dynamic for the benefit of shellcheck
28 #for x in /a/bin/distro-functions/src/* /a/bin/!(githtml)/*-function?(s); do echo source $x ; done
29 source /a/bin/distro-functions/src/identify-distros
30 source /a/bin/distro-functions/src/package-manager-abstractions
31 source /a/bin/log-quiet/logq-function
32 source /a/bin/small-misc-bash/psg-function
33 # for x in /a/bin/bash_unpublished/source-!(.#*); do echo source $x; done
34 source /a/bin/bash_unpublished/source-semi-priv
35 source /a/bin/bash_unpublished/source-state
36
37 source /a/bin/log-quiet/logq-function
38
39
40
41 # * functions
42
43
44
45 # todo, update this
46 complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
47
48
49 anki() {
50 if which anki &>/dev/null; then
51 command anki
52 else
53 schroot -c anki -- anki
54 fi
55 }
56
57 acat() {
58 shopt -s nullglob
59 hrcat /m/md/alerts/new/* /m/md/alerts/cur/*
60 shopt -u nullglob
61 }
62 aclear() {
63 shopt -s nullglob
64 files=(/m/md/alerts/new/* /m/md/alerts/cur/*)
65 if (( ${#files[@]} )); then
66 rm -f ${files[@]}
67 fi
68 shopt -u nullglob
69 system-status _
70 }
71
72 ap() {
73 # pushd in case current directory has an ansible.cfg file
74 pushd /a/xans >/dev/null
75 ansible-playbook -v -l ${1:- $(hostname -f)} site.yml
76 popd >/dev/null
77 }
78 aw() {
79 pushd /a/work/ansible-configs >/dev/null
80 time ansible-playbook -v -i inventory adhoc.yml "$@"
81 popd >/dev/null
82 }
83 ad() {
84 pushd /a/bin/distro-setup/a >/dev/null
85 ansible-playbook site.yml
86 popd >/dev/null
87 }
88
89 astudio() {
90 # googling android emulator libGL error: failed to load driver: r600
91 # lead to http://stackoverflow.com/a/36625175/14456
92 export ANDROID_EMULATOR_USE_SYSTEM_LIBS=1
93 /a/opt/android-studio/bin/studio.sh "$@" &r;
94 }
95
96 bindpush() {
97 lipush || return 1
98 for h in li l2; do
99 sl $h <<'EOF' || return 1
100 set -e
101 conflink
102 f=/var/lib/bind/db.b8.nz
103 ser stop bind9
104 s rm -fv $f.jnl
105 s install -m 644 -o bind -g bind /p/c/machine_specific/linode/bind-initial/db.b8.nz $f
106 ser restart bind9
107 EOF
108 done
109 }
110
111 bbk() { # btrbk wrapper
112 c /
113 local active=true
114 systemctl is-active btrbk.timer || active=false
115 if $active; then
116 ser disable btrbk.timer
117 fi
118 if systemctl is-active btrbk.service; then
119 $active && ser enable btrbk.timer
120 echo "cron btrbk is already running"
121 return 1
122 fi
123 # run latest
124 install-my-scripts
125 btrbk-run "$@" | pee cat "systemd-cat -t btrbk-run"
126 $active && ser enable btrbk.timer
127 }
128
129 bfg() { java -jar /a/opt/bfg-1.12.14.jar "$@"; }
130
131 bigclock() {
132 xclock -digital -update 1 -face 'arial black-80:bold'
133 }
134
135 bpull() {
136 [[ $1 ]] || return 1
137 c /
138 # run latest
139 install-my-scripts
140 switch-mail-host $1 $HOSTNAME | pee cat "systemd-cat -t switch-mail-host"
141 }
142 bpush() {
143 [[ $1 ]] || return 1
144 c /
145 # run latest
146 install-my-scripts
147 switch-mail-host $HOSTNAME $1 | pee cat "systemd-cat -t switch-mail-host"
148 }
149 lipush() {
150 # note, i had --delete-excluded, but that deletes all files in --exclude-from on
151 # the remote site, which doesn't make sense, so not sure why i had it.
152 local p a
153 p=(/a/bin /a/exe /a/h /a/c /p/c/machine_specific/linode{,.hosts} /a/opt/{emacs,emacs-debianstable,mu})
154 a="-ahviSAXPH --specials --devices --delete --relative --exclude-from=/p/c/li-rsync-excludes"
155 ret=0
156 m rsync $@ $a ${p[@]} /p/c/machine_specific/l2 root@l2.b8.nz:/ || ret=$?
157 m rsync $@ $a ${p[@]} /p/c/machine_specific/li root@li.b8.nz:/ || ret=$?
158 m rsync $@ -ahviSAXPH root@iankelling.org:/a/h/proposed-comments/ /a/h/proposed-comments || ret=$?
159 return $ret
160 }
161 lipushnoe() { # noe = noemacs. for running faster.
162 rsync $@ --delete-excluded -ahviSAXPH --specials --devices --delete --relative \
163 --exclude-from=/p/c/li-rsync-excludes /a/bin /a/exe /a/h /a/c /p/c/machine_specific/li root@li:/
164 }
165
166 #### begin bitcoin related things
167 btc() {
168 local f=/etc/bitcoin/bitcoin.conf
169 # importprivkey will timeout if using the default of 15 mins.
170 # upped it to 1 hour.
171 bitcoin-cli -rpcclienttimeout=60000 -$(s grep rpcuser= $f) -$(s grep rpcpassword= $f) "$@"
172 }
173 btcusd() { # $1 btc in usd
174 local price
175 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
176 printf "$%s\n" "$price"
177 if [[ $1 ]]; then
178 printf "$%.2f\n" "$(echo "scale=4; $price * $1"| bc -l)"
179 fi
180 }
181 usdbtc() { # $1 usd in btc
182 local price
183 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
184 printf "$%s\n" "$price"
185 if [[ $1 ]]; then
186 # 100 mil satoshi / btc. 8 digits after the 1.
187 printf "%.8f btc\n" "$(echo "scale=10; $1 / $price "| bc -l)"
188 fi
189 }
190 satoshi() { # $1 satoshi in usd
191 local price
192 price="$(curl -s https://api.coinbase.com/v2/prices/BTC-USD/spot | jq -r .data.amount)"
193 price=$(echo "scale=10; $price * 0.00000001"| bc -l)
194 printf "$%f\n" "$price"
195 if [[ $1 ]]; then
196 printf "$%.2f\n" "$(echo "scale=10; $price * $1"| bc -l)"
197 fi
198 }
199 #### end bitcoin related things
200
201
202
203 cbfstool () { /a/opt/coreboot/build/cbfstool "$@"; }
204
205
206 cgpl()
207 {
208 if (($#)); then
209 cp /a/bin/data/COPYING "$@"
210 else
211 cp /a/bin/data/COPYING .
212 fi
213 }
214
215 capache()
216 {
217 if (($#)); then
218 cp /a/bin/data/LICENSE "$@"
219 else
220 cp /a/bin/data/LICENSE .
221 fi
222 }
223
224 chrome() {
225 if type -p chromium &>/dev/null; then
226 cmd=chromium
227 else
228 cd
229 cmd="schroot -c stretch chromium"
230 CHROMIUM_FLAGS='--enable-remote-extensions' $cmd &r
231 fi
232 }
233
234
235 # do all tee.
236 # pipe to this, or just type like a shell
237 dat() {
238 tee >(ssh frodo.b8.nz bash -l) >(ssh x2 bash -l) >(ssh tp.b8.nz bash -l) >(ssh kw bash -l) >(ssh tp.b8.nz bash -l)
239 }
240 da() { # do all
241 local host
242 for host in x2 kw tp.b8.nz x3.b8.nz frodo.b8.nz; do
243 ssh $host "$@"
244 done
245 }
246
247
248 debian_pick_mirror () {
249 # netselect-apt finds a fast mirror.
250 # but we need to replace the mirrors ourselves,
251 # because it doesnt do that. best it can do is
252 # output a basic sources file
253 # here we get the server it found, get the main server we use
254 # then substitute all instances of one for the other in the sources file
255 # and backup original to /etc/apt/sources.list-original.
256 # this is idempotent. the only way to identify debian sources is to
257 # note the original server, so we put it in a comment so we can
258 # identify it later.
259 local file
260 file=$(mktemp -d)/f # safe way to get file name without creating one
261 sudo netselect-apt -o "$file" || return 1
262 url=$(grep ^\\w $file | head -n1 | awk '{print $2}')
263 sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
264 sudo sed -ri "/http.us.debian.org/ s@( *[^ #]+ +)[^ ]+([^#]+).*@\1$url\2# http.us.debian.org@" /etc/apt/sources.list
265 sudo apt-get update
266 }
267 digme() {
268 digdiff @ns{1,2}.iankelling.org "$@"
269 }
270
271
272 dup() {
273 local ran_d
274 ran_d=false
275 case $PS1 in
276 *DISTRO-BEGIN!*|*DISTRO!*)
277 /b/ds/distro-begin || return $?
278 ran_d=true
279 ;;&
280 *DISTRO-END!*|*DISTRO!*)
281 /b/ds/distro-end || return $?
282 ran_d=true
283 ;;&
284 *CONFLINK*)
285 if ! $ran_d; then
286 conflink
287 fi
288 ;;
289 esac
290 system-status _
291 }
292
293 envload() { # load environment from a previous: export > file
294 local file=${1:-$HOME/.${USER}_env}
295 eval "$(export | sed 's/^declare -x/export -n/')"
296 while IFS= read -r line; do
297 # declare -x makes variables local to a function
298 eval ${line/#declare -x/export}
299 done < "$file"
300 }
301
302
303 # one that comes with distros is too old for newer devices
304 fastboot() {
305 /a/opt/android-platform-tools/fastboot "$@";
306 }
307
308 kdecd() { /usr/lib/x86_64-linux-gnu/libexec/kdeconnectd; }
309
310 # List of apps to install/update
311 # Create from existing manually installed apps by doing
312 # fdroidcl update
313 # fdroidcl search -i, then manually removing
314 # automatically installed/preinstalled apps
315
316 #
317 # # my attempt at recovering from boot loop:
318 # # in that case, boot to recovery (volume up, home button, power, let go of power after samsun logo)
319 # # then
320 # mount /dev/block/mmcblk0p12 /data
321 # cd /data
322 # find -iname '*appname*'
323 # rm -rf FOUND_DIRS
324 # usually good enough to just rm -rf /data/app/APPNAME
325 #
326 # currently broken:
327 # # causes replicant to crash
328 # org.quantumbadger.redreader
329 # org.kde.kdeconnect_tp
330
331 # not broke, but wont work without gps
332 #com.zoffcc.applications.zanavi
333 # not broke, but not using atm
334 #com.nutomic.syncthingandroid
335 # # doesn\'t work on replicant
336 #net.sourceforge.opencamera
337 #
338 fdroid_pkgs=(
339 de.marmaro.krt.ffupdater
340 me.ccrama.redditslide
341 org.fedorahosted.freeotp
342 at.bitfire.davdroid
343 com.alaskalinuxuser.justnotes
344 com.artifex.mupdf.viewer.app
345 com.danielkim.soundrecorder
346 com.fsck.k9
347 com.ghostsq.commander
348 com.ichi2.anki
349 com.jmstudios.redmoon
350 com.jmstudios.chibe
351 org.kde.kdeconnect_tp
352 com.notecryptpro
353 com.termux
354 cz.martykan.forecastie
355 de.danoeh.antennapod
356 de.blinkt.openvpn
357 de.marmaro.krt.ffupdater
358 eu.siacs.conversations
359 free.rm.skytube.oss
360 im.vector.alpha # riot
361 info.papdt.blackblub
362 me.tripsit.tripmobile
363 net.gaast.giggity
364 net.minetest.minetest
365 net.osmand.plus
366 org.isoron.uhabits
367 org.linphone
368 org.gnu.icecat
369 org.smssecure.smssecure
370 org.yaaic
371 sh.ftp.rocketninelabs.meditationassistant.opensource
372 )
373 # https://forum.xda-developers.com/android/software-hacking/wip-selinux-capable-superuser-t3216394
374 # for maru,
375 #me.phh.superuser
376
377 fdup() {
378 local -A installed updated
379 local p
380 fdroidcl update
381 if fdroidcl search -u | grep ^org.fdroid.fdroid; then
382 fdroidcl install org.fdroid.fdroid
383 sleep 5
384 fdroidcl update
385 fi
386 for p in $(fdroidcl search -i| grep -o "^\S\+"); do
387 installed[$p]=true
388 done
389 for p in $(fdroidcl search -u| grep -o "^\S\+"); do
390 updated[$p]=false
391 done
392 for p in ${fdroid_pkgs[@]}; do
393 if ! ${installed[$p]:-false}; then
394 fdroidcl install $p
395 # sleeps are just me being paranoid since replicant has a history of crashing when certain apps are installed
396 sleep 5
397 fi
398 done
399 for p in ${!installed[@]}; do
400 if ! ${updated[$p]:-true}; then
401 fdroidcl install $p
402 sleep 5
403 fi
404 done
405 }
406
407 firefox-default-profile() {
408 key=Default value=1 section=$1
409 file=/p/c/subdir_files/.mozilla/firefox/profiles.ini
410 sed -ri "/^ *$key/d" "$file"
411 sed -ri "/ *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d};/ *\[$section\]/a $key=$value" "$file"
412 }
413 fdhome() { #firefox default home profile
414 firefox-default-profile Profile0
415 }
416
417 fdwork() {
418 firefox-default-profile Profile4
419 }
420
421 ff() {
422 if type -P firefox &>/dev/null; then
423 firefox "$@"
424 else
425 iceweasel "$@"
426 fi
427 }
428
429
430
431 fn() {
432 firefox -P alt "$@" >/dev/null 2>&1
433 }
434
435
436 fsdiff () {
437 local missing=false
438 local dname="${PWD##*/}"
439 local m="/a/tmp/$dname-missing"
440 local d="/a/tmp/$dname-diff"
441 [[ -e $d ]] && rm "$d"
442 [[ -e $m ]] && rm "$m"
443 local msize=0
444 local fsfile
445 while read -r line; do
446 fsfile="$1${line#.}"
447 if [[ -e "$fsfile" ]]; then
448 md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
449 else
450 missing=true
451 echo "$line" >> "$m"
452 msize=$((msize + 1))
453 fi
454 done < <(find . -type f )
455 if $missing; then
456 echo "$m"
457 (( msize <= 100 )) && cat $m
458 fi
459 }
460 fsdiff-test() {
461 # expected output, with different tmp dirs
462 # /tmp/tmp.HDPbwMqdC9/c/d ./c/d
463 # /a/tmp/tmp.qLDkYxBYPM-missing
464 # ./b
465 cd $(mktemp -d)
466 echo ok > a
467 echo nok > b
468 mkdir c
469 echo ok > c/d
470 local x
471 x=$(mktemp -d)
472 mkdir $x/c
473 echo different > $x/c/d
474 echo ok > $x/a
475 fsdiff $x
476 }
477 rename-test() {
478 # test whether missing files were renamed, generally for use with fsdiff
479 # $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
480 # echos non-renamed files
481 local x y found
482 unset sums
483 for x in "$2"/*; do
484 { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
485 done
486 while read -r line; do
487 { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
488 renamed=false
489 for x in "${sums[@]}"; do
490 if [[ $missing_sum == "$x" ]]; then
491 renamed=true
492 break
493 fi
494 done
495 $renamed || echo "$line"
496 done < "$1"
497 return 0
498 }
499
500 feh() {
501 # F = fullscren, z = random, Z = auto zoom
502 command feh -FzZ "$@"
503 }
504
505
506
507 fw() {
508 firefox -P default "$@" >/dev/null 2>&1
509 }
510
511
512 gitian() {
513 git config user.email ian@iankelling.org
514 }
515
516
517 # at least in flidas, things rely on gpg being gpg1
518 gpg() {
519 command gpg2 "$@"
520 }
521
522 gse() {
523 local email=ian@iankelling.org
524 if readlink ~/.mu | grep fsf &>/dev/null; then
525 email=iank@fsf.org
526 fi
527 git send-email --notes "--envelope-sender=<$email>" \
528 --suppress-cc=self "$@"
529 }
530
531
532 hstatus() {
533 # do git status on published repos.
534 c /a/bin/githtml
535 for x in *; do
536 cd $(readlink -f $x)/..
537 status=$(i status -s) || pwd
538 if [[ $status ]]; then
539 hr
540 echo $x
541 printf "%s\n" "$status"
542 fi
543 cd /a/bin/githtml
544 done
545 }
546
547
548 idea() {
549 /a/opt/idea-IC-163.7743.44/bin/idea.sh "$@" &r
550 }
551
552 o() {
553 if type gvfs-open &> /dev/null ; then
554 gvfs-open "$@"
555 else
556 xdg-open "$@"
557 fi
558 # another alternative is run-mailcap
559 }
560
561 jfilter() {
562 grep -Evi -e "^(\S+\s+){4}(sudo|sshd|cron)\[\S*:" \
563 -e "^(\S+\s+){4}systemd\[\S*: (starting|started) (btrfsmaintstop|dynamicipupdate|spamd dns bug fix cronjob|rss2email)\.*$"
564 }
565 jtail() {
566 journalctl -n 10000 -f "$@" | jfilter
567 }
568 jr() { journalctl "$@" | jfilter | less ; }
569 jrf() { journalctl -f "$@" | jfilter; }
570
571
572 kff() { # keyboardio firmware flash
573 pushd /a/bin/distro-setup/Arduino/Model01-Firmware
574 yes $'\n' | make flash
575 popd
576 }
577
578
579
580 lom() {
581 local l base
582 if [[ $1 == /* ]]; then
583 base=${1##*/}
584 if mountpoint /mnt/$base; then
585 return 0
586 fi
587 l=$(sudo losetup -f)
588 sudo losetup $l $1
589 if ! sudo cryptsetup luksOpen $l $base; then
590 sudo losetup -d $l
591 return 1
592 fi
593 sudo mkdir -p /mnt/$base
594 sudo mount /dev/mapper/$base /mnt/$base
595 sudo chown $USER:$USER /mnt/$base
596 else
597 base=$1
598 sudo umount /mnt/$base
599 l=$(sudo cryptsetup status /dev/mapper/$base|sed -rn 's/^\s*device:\s*(.*)/\1/p')
600 sudo cryptsetup luksClose /dev/mapper/$base || return 1
601 sudo losetup -d $l
602 fi
603 }
604
605
606 mbenable() {
607 local mb=$1
608 dst=/m/4e/$mb
609 src=/m/md/$mb
610 set -x
611 [[ -e $src ]] || { set +x; return 1; }
612 mv -T $src $dst || { set +x; return 1; }
613 ln -s -T $dst $src
614 /a/exe/lnf /m/.mu ~
615 mu index --maildir=/m/4e
616 set +x
617 }
618 mbdisable() {
619 local mb=$1
620 dst=/m/md/$mb
621 src=/m/4e/$mb
622 set -x
623 [[ -e $src ]] || { set +x; return 1; }
624 if [[ -L $dst ]]; then rm $dst; fi
625 mv -T $src $dst
626 set +x
627 }
628
629
630 mdt() {
631 markdown "$1" >/tmp/mdtest.html
632 firefox /tmp/mdtest.html
633 }
634
635
636
637 mo() { xset dpms force off; } # monitor off
638
639 net-dev-info() {
640 e "lspci -nnk|gr -iA2 net"
641 lspci -nnk|gr -iA2 net
642 hr
643 e "s lshw -C network"
644 hr
645 s lshw -C network
646
647 }
648
649 nk() {
650 ser stop NetworkManager
651 ser stop dnsmasq
652 s resolvconf -d NetworkManager
653 ser start dnsmasq
654 s ifup br0
655 }
656 ngo() {
657 s ifdown br0
658 ser start NetworkManager
659 sleep 4
660 s nmtui-connect
661 }
662
663 otp() {
664 oathtool --totp -b "$@" | xclip -selection clipboard
665 }
666
667
668 pakaraoke() {
669 # from http://askubuntu.com/questions/456021/remove-vocals-from-mp3-and-get-only-instrumentals
670 pactl load-module module-ladspa-sink sink_name=Karaoke master=alsa_output.usb-Audioengine_Audioengine_D1-00.analog-stereo plugin=karaoke_1409 label=karaoke control=-30
671 }
672
673 pfind() { #find *$1* in $PATH
674 [[ $# != 1 ]] && { echo requires 1 argument; return 1; }
675 local pathArray
676 IFS=: pathArray=($PATH); unset IFS
677 find "${pathArray[@]}" -iname "*$1*"
678 }
679
680 pick-trash() {
681 # trash-restore lists everything that has been trashed at or below CWD
682 # This picks out files just in CWD, not subdirectories,
683 # which also match grep $1, usually use $1 for a time string
684 # which you get from running restore-trash once first
685 local name x ask
686 local nth=1
687 # last condition is to not ask again for ones we skipped
688 while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
689 && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
690 name="$(echo "$name" | head -n $nth | tail -n 1 )"
691 read -r -p "$name [Y/n] " ask
692 if [[ ! $ask || $ask == [Yy] ]]; then
693 x=$( echo "$name" | gr -o "^\s*[0-9]*" )
694 echo $x | restore-trash > /dev/null
695 elif [[ $ask == [Nn] ]]; then
696 nth=$((nth+1))
697 else
698 return
699 fi
700 done
701 }
702
703
704 pub() {
705 rld /a/h/_site/ li:/var/www/iankelling.org/html
706 }
707
708
709 pumpa() {
710 # fixes the menu bar in xmonad. this won\'t be needed when xmonad
711 # packages catches up on some changes in future (this is written in
712 # 4/2017)
713 #
714 # geekosaur: so youll want to upgrade to xmonad 0.13 or else use a
715 # locally modified XMonad.Hooks.ManageDocks that doesnt set the
716 # work area; turns out it\'s impossible to set correctly if you are
717 # not a fully EWMH compliant desktop environment
718 #
719 # geekosaur: chrome shows one failure mode, qt/kde another, other
720 # gtk apps a third, ... I came up with a setting that works for me
721 # locally but apparently doesnt work for others, so we joined the
722 # other tiling window managers in giving up on setting it at all
723 #
724 xprop -root -remove _NET_WORKAREA
725 command pumpa &r
726 }
727
728 # reviewboard, used at my old job
729 #rbpipe() { rbt post -o --diff-filename=- "$@"; }
730 #rbp() { rbt post -o "$@"; }
731
732 rebr() {
733 s ifdown br0
734 s ifup br0
735 }
736
737 resolvcat() {
738 local f
739 f=/etc/resolv.conf
740 echo $f:; ccat $f
741 hr; echo dnsmasq is $(systemctl is-active dnsmasq)
742 f=/var/run/dnsmasq/resolv.conf
743 hr; echo $f:; ccat $f
744 f=/etc/dnsmasq-servers.conf
745 hr; echo $f:; ccat $f
746 }
747
748 # only run on MAIL_HOST. simpler to keep this on one system.
749 r2eadd() { # usage: name url
750 # initial setup of rss2email:
751 # r2e new r2e@iankelling.org
752 # that initializes files, and sets default email.
753 # symlink to the config doesnt work, so I copied it to /p/c
754 # and then use cli option to specify explicit path.
755 # Only option changed from default config is to set
756 # force-from = True
757 #
758 # or else for a few feeds, the from address is set by the feed, and
759 # if I fail delivery, then I send a bounce message to that from
760 # address, which makes me be a spammer.
761
762 r2e add $1 "$2" $1@r2e.iankelling.org
763 # get up to date and dont send old entries now:
764 r2e run --no-send $1
765 }
766 r2e() { command r2e -d /p/c/rss2email.json -c /p/c/rss2email.cfg "$@"; }
767
768 rspicy() { # usage: HOST DOMAIN
769 # connect to spice vm remote host. use vspicy for local host
770 local port
771 # shellcheck disable=SC2087
772 port=$(ssh $1<<EOF
773 sudo virsh dumpxml $2|grep "<graphics.*type='spice'" | \
774 sed -rn "s/.*port='([0-9]+).*/\1/p"
775 EOF
776 )
777 if [[ $port ]]; then
778 spicy -h $1 -p $port
779 else
780 echo "error: no port found. check that the domain is running."
781 fi
782 }
783
784
785 scssl() {
786 # s gem install scss-lint
787 pushd /a/opt/thoughtbot-guides
788 git pull --stat
789 popd
790 scss-lint -c /a/opt/thoughtbot-guides/style/sass/.scss-lint.yml "$@"
791 }
792
793 skaraoke() {
794 local tmp out
795 out=${2:-${1%.*}.sh}
796 tmp=$(mktemp -d)
797 script -t -c "mpv --no-config --no-resume-playback --no-terminal --no-audio-display '$1'" $tmp/typescript 2>$tmp/timing
798 # todo, the current sleep seems pretty good, but it
799 # would be nice to have an empirical measurement, or
800 # some better wait to sync up.
801 #
802 # note: --loop-file=no prevents it from hanging if you have that
803 # set to inf the mpv config.
804 # --loop=no prevents it from exit code 3 due to stdin if you
805 # had it set to inf in mpv config.
806 #
807 # args go to mpv, for example --volume=80, 50%
808 cat >$out <<EOFOUTER
809 #!/bin/bash
810 trap "trap - TERM && kill 0" INT TERM ERR; set -e
811 ( sleep .2; scriptreplay <( cat <<'EOF'
812 $(cat $tmp/timing)
813 EOF
814 ) <( cat <<'EOF'
815 $(cat $tmp/typescript)
816 EOF
817 ))&
818 base64 -d - <<'EOF'| mpv --loop=no --loop-file=no --no-terminal --no-audio-display "\$@" -
819 $(base64 "$1")
820 EOF
821 kill 0
822 EOFOUTER
823 rm -r $tmp
824 chmod +x $out
825 }
826
827 smeld() { # ssh meld usage host1 host2 file
828 meld <(ssh $1 cat $3) <(ssh $2 cat $3)
829 }
830
831 spd() {
832 PATH=/usr/local/spdhackfix:$PATH command spd "$@"
833 }
834
835 spend() {
836 s systemctl suspend
837 }
838
839 # ssh, copy my universal config over if needed.
840
841 # By default .bashrc is sourced for ALL ssh commands. This is wonky.
842 # Normally, this file is not sourced when a script is run, but we can
843 # override that by having #!/bin/bash -l. I want the same thing for ssh
844 # commands. when a local script runs an ssh command, bashrc should not be
845 # sourced, unless we use a modified command.
846 #
847 # So, in my bashrc, test for conditions of noninteractive ssh and return
848 # if so. And we don't keep the rest of the code in .bashrc, because
849 # even though we return, we parse the whole file which can cause errors
850 # as we develop it.
851 #
852 # To test for an overriding condition: bash builtin vars and env show no
853 # difference in ssh vs local, except shell level which is not
854 # reliable. one option is to use an environment variable. env variables
855 # sent across ssh are strictly limited. We could override an obscure
856 # unused LC_var, like telephone, but I don't want to run into some edge
857 # case where that messes things up. I choose to set SendEnv and
858 # AcceptEnv ssh config vars to allow the environment variable BRC to
859 # propagate across ssh, and for hosts I don't control, I start an inner
860 # shell with it set, which doubles up as a way to have a nondefault
861 # bashrc.
862 sl() {
863 # inspired from https://github.com/Russell91/sshrc
864
865
866 local args info_date info_t type now tmp tmp2 old sshinfo cmd haveinfo dorsync info_sec
867 declare -a args tmpa
868 now=$(date +%s)
869
870 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
871 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
872 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
873 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
874 # [command]
875
876 while [[ $1 ]]; do
877 case "$1" in
878 -[1246AaCfGgKkMNnqsTtVvXxYy])
879 args+=("$1"); shift
880 ;;
881 -[bcDEeFIiLlmOopQRSWw])
882 # -oOption etc is valid
883 if (( ${#1} >= 3 )); then
884 args+=("$1"); shift
885 else
886 args+=("$1" "$2"); shift 2
887 fi
888 ;;
889 *)
890 break
891 ;;
892 esac
893 done
894 remote="$1"; shift
895 if [[ ! $remote ]]; then
896 echo $0: error hostname required >&2
897 return 1
898 fi
899 dorsync=false
900 haveinfo=false
901 tmpa=(/p/sshinfo/???????????"$remote")
902 sshinfo=${tmpa[0]}
903 if [[ -e $sshinfo ]]; then
904 haveinfo=true
905 fi
906 if $haveinfo; then
907 tmp=${sshinfo[0]##*/}
908 tmp2=${tmp::11}
909 type=${tmp2: -1}
910 if [[ $type == b ]]; then
911 info_sec=${tmp::10}
912 if (( $(stat -c%Y /b/ds/brc) > info_sec || $(stat -c%Y /b/ds/.bashrc) > info_sec )); then
913 dorsync=true
914 rm -f $sshinfo
915 fi
916 fi
917 else
918 dorsync=true
919 # use this weird yes thing to ensure we know ssh succeeded
920 tmp=$(command ssh "${args[@]}" "$remote" "if test -e /a/bin/ds/.bashrc -a -L .bashrc; then echo yes; fi") || return
921 if [[ $tmp == yes ]]; then
922 type=a
923 else
924 type=b
925 fi
926 fi
927 if $dorsync || ! $haveinfo; then
928 sshinfo=/p/sshinfo/$now$type"$remote"
929 touch $sshinfo
930 chmod 666 $sshinfo
931 fi
932 if [[ $type == b ]]; then
933 if $dorsync; then
934 RSYNC_RSH="ssh ${args[*]}" rsync -rptL /b/ds/sl/.iank "$remote":
935 fi
936 if (( ${#@} )); then
937
938 # Theres a couple ways to do this. im not sure whats best,
939 # but relying on bash 4.4+ escape quoting seems most reliable.
940 command ssh "${args[@]}" "$remote" \
941 BRC=t bash -c '"\"\$@\""' bash ${@@Q}
942 else
943 # -t gives us an interactive shell for normal ssh. -l makes us use the rcfile when piping commands.
944 command ssh -t "${args[@]}" "$remote" BRC=t INPUTRC=.iank/.inputrc bash --rcfile .iank/.bashrc -l
945 fi
946 else
947 BRC=t command ssh "$remote" "$@"
948 fi
949 }
950 sss() { # ssh solo
951 ssh -oControlMaster=no -oControlPath=/ "$@"
952 }
953 # kill off old shared socket then ssh
954 ssk() {
955 local -a opts=()
956 while [[ $1 == -* ]]; do
957 opts+=("$1")
958 shift
959 done
960 m pkill -f "^ssh: /tmp/ssh_mux_${USER}_${1#*@}_22_"
961 m ssh "${opts[@]}" "$@"
962 }
963 # plain limited ssh
964 ssh() {
965 BRC=t command ssh "$@"
966 }
967
968
969 # mail related
970 testmail() {
971 declare -gi _seq; _seq+=1
972 echo "test body" | m mail -s "test mail from $HOSTNAME, $_seq" "${@:-root@localhost}"
973 # for testing to send from an external address, you can do for example
974 # -fian@iank.bid -aFrom:ian@iank.bid web-6fnbs@mail-tester.com
975 # note in exim, you can retry a deferred message
976 # s exim -M MSG_ID
977 # MSG_ID is in /var/log/exim4/mainlog, looks like 1ccdnD-0001nh-EN
978 }
979
980 # to test sieve, use below command. for fsf mail, see offlineimap-sync script
981 # make modifications, then copy to live file, use -eW to actually modify mailbox
982 #
983 # Another option is to use sieve-test SCRIPT MAIL_FILE. note,
984 # sieve-test doesnt know about envelopes, Im not sure if sieve-filter does.
985
986 # sieve with output filter. arg is mailbox, like INBOX.
987 # This depends on dovecot conf, notably mail_location in /etc/dovecot/conf.d/10-mail.conf
988
989 _dosieve() {
990 sieve-filter "$@" 2> >(head; tail) >/tmp/testsieve.log && sed -rn '/^Performed actions:/,/^[^ ]/{/^ /p}' /tmp/testsieve.log | sort | uniq -c
991 }
992
993 # always run this first, edit the test files, then run the following
994 testsieve() {
995 _dosieve ~/sieve/maintest.sieve ${1:-INBOX} delete
996 }
997 runsieve() {
998 c ~/sieve; cp personal{test,}.sieve; cp lists{test,}.sieve; cp personalend{test,}.sieve
999 _dosieve ~/sieve/main.sieve -eW ${1:-INBOX} delete
1000 }
1001
1002 # mail related
1003 testexim() {
1004 # testmail above calls sendmail, which is a link to exim/postfix.
1005 # its docs dont say a way of adding an argument
1006 # to sendmail to turn on debug output. We could make a wrapper, but
1007 # that is a pain. Exim debug args are documented here:
1008 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-the_exim_command_line.html
1009 #
1010 # http://www.exim.org/exim-html-current/doc/html/spec_html/ch-building_and_installing_exim.html
1011 # note, for exim daemon, you can turn on debug options by
1012 # adding -d, etc to COMMONOPTIONS in
1013 # /etc/default/exim4
1014 #
1015 # to specify recipients other than those in to, cc, bcc, you can use the cli args, eg:
1016 # exim -i 'test@zroe.org, t2@zroe.org' <<'EOF'
1017 #
1018 #
1019 exim -d -t <<'EOF'
1020 From: i@dmarctest.b8.nz
1021 To: mailman@dev.fsf.org
1022 Subject: test2
1023 Reply-to: rtest@iankelling.org
1024
1025 This is a test message.
1026 EOF
1027 }
1028
1029 # toggle keyboard
1030 tk() {
1031 # based on
1032 # https://askubuntu.com/questions/160945/is-there-a-way-to-disable-a-laptops-internal-keyboard
1033 id=$(xinput --list --id-only 'AT Translated Set 2 keyboard')
1034 if xinput list | grep -F '∼ AT Translated Set 2 keyboard' &>/dev/null; then
1035 echo enabling keyboard
1036 # find the first slave keyboard number, they are all the same in my output.
1037 # if they werent, worst case we would need to save the slave number somewhere
1038 # when it got disabled.
1039 slave=$(xinput list | sed -n 's/.*slave \+keyboard (\([0-9]*\)).*/\1/p' | head -n1)
1040 xinput reattach $id $slave
1041 else
1042 xinput float $id
1043 fi
1044 }
1045
1046 tm() {
1047 # timer in minutes
1048 # --no-config
1049 (sleep $(calc "$* * 60") && mpv --no-config --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
1050 }
1051
1052 trg() { transmission-remote-gtk&r; }
1053 trc() {
1054 # example, set global upload limit to 100 kilobytes:
1055 # trc -u 100
1056 TR_AUTH=":$(jq -r .profiles[0].password ~/.config/transmission-remote-gtk/config.json)" transmission-remote transmission.lan -ne "$@"
1057 }
1058
1059
1060 tu() {
1061 local s dir
1062 dir="$(dirname "$1")"
1063 if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
1064 s=s;
1065 fi
1066 # full path for using in some initial setup steps
1067 $s /a/exe/teeu "$@"
1068 }
1069
1070 vpncmd() {
1071 #m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*pia.conf") -n -m "$@"
1072 m s nsenter -t $(pgrep -f "/usr/sbin/openvpn .* --config /etc/openvpn/.*client.conf") -n -m "$@"
1073 }
1074 vpnf() {
1075 vpncmd gksudo -u iank "firefox -no-remote -P vpn" &r
1076 }
1077 vpni() {
1078 vpncmd gksudo -u iank "$*"
1079 }
1080 vpnbash() {
1081 vpncmd bash
1082 }
1083
1084
1085 vpn() {
1086 if [[ -e /lib/systemd/system/openvpn-client@.service ]]; then
1087 local vpn_service=openvpn-client
1088 else
1089 local vpn_service=openvpn
1090 fi
1091
1092 [[ $1 ]] || { echo need arg; return 1; }
1093 journalctl --unit=$vpn_service@$1 -f -n0 &
1094 s systemctl start $vpn_service@$1
1095 # sometimes the ask-password agent does not work and needs a delay.
1096 sleep .5
1097 # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=779240
1098 # noticed around 8-2017 after update from around stretch release
1099 # on debian testing, even though the bug is much older.
1100 s systemd-tty-ask-password-agent
1101 }
1102
1103 vpnoff() {
1104 [[ $1 ]] || { echo need arg; return 1; }
1105 if [[ -e /lib/systemd/system/openvpn-client@.service ]]; then
1106 local vpn_service=openvpn-client
1107 else
1108 local vpn_service=openvpn
1109 fi
1110 s systemctl stop $vpn_service@$1
1111 }
1112
1113
1114
1115
1116 vspicy() { # usage: VIRSH_DOMAIN
1117 # connect to vms made with virt-install
1118 spicy -p $(sudo virsh dumpxml "$1"|grep "<graphics.*type='spice'"|\
1119 sed -r "s/.*port='([0-9]+).*/\1/")
1120 }
1121
1122 wian() {
1123 cat-new-files /m/4e/INBOX/new
1124 }
1125
1126 wtr() { curl wttr.in/boston; }
1127
1128 xevkb() { xev -event keyboard; }
1129
1130 # * misc stuff
1131
1132 # from curl cheat.sh/:bash_completion
1133 _cheatsh_complete_curl()
1134 {
1135 local cur prev opts
1136 _get_comp_words_by_ref -n : cur
1137
1138 COMPREPLY=()
1139 #cur="${COMP_WORDS[COMP_CWORD]}"
1140 prev="${COMP_WORDS[COMP_CWORD-1]}"
1141 opts="$(curl -s cheat.sh/:list | sed s@^@cheat.sh/@)"
1142
1143 if [[ ${cur} == cheat.sh/* ]] ; then
1144 COMPREPLY=( $(compgen -W "${opts}" -- ${cur}) )
1145 __ltrim_colon_completions "$cur"
1146 return 0
1147 fi
1148 }
1149 complete -F _cheatsh_complete_curl curl
1150
1151
1152
1153
1154 reset-konsole() {
1155 # we also have a file in /a/c/...konsole...
1156 local f=$HOME/.config/konsolerc
1157 setini DefaultProfile profileian.profile "Desktop Entry" $f
1158 setini Favorites profileian.profile "Favorite Profiles" $f
1159 setini ShowMenuBarByDefault false KonsoleWindow $f
1160 setini TabBarPosition Top TabBar $f
1161 }
1162
1163 reset-sakura() {
1164 while -r read k v; do
1165 # shellcheck disable=SC2154
1166 setini $k $v sakura /a/c/subdir_files/.config/sakura/sakura.conf
1167 done <<'EOF'
1168 colorset1_back rgb(33,37,39
1169 less_questions true
1170 audible_bell No
1171 visible_bell No
1172 disable_numbered_tabswitch true
1173 scroll_lines 10000000
1174 scrollbar true
1175 EOF
1176 }
1177
1178 reset-xscreensaver() {
1179 # except for spash, i set these by setting gui options in
1180 # xscreensaver-command -demo
1181 # then finding the corresponding option in .xscreensaver
1182 # spash, i happened to notice in .xscreensaver
1183 #
1184 # dpmsOff, monitor doesnt come back on using old free software supported nvidia card
1185 cat > /home/iank/.xscreensaver <<'EOF'
1186 mode: blank
1187 dpmsEnabled: True
1188 dpmsStandby: 0:02:00
1189 dpmsSuspend: 0:03:00
1190 dpmsOff: 0:00:00
1191 timeout: 0:02:00
1192 lock: True
1193 lockTimeout: 0:03:00
1194 splash: False
1195 EOF
1196
1197 }
1198
1199
1200 # * stuff that makes sense to be at the end
1201 if [[ "$SUDOD" ]]; then
1202 cd "$SUDOD"
1203 unset SUDOD
1204 elif [[ -d /a ]] && [[ $PWD == "$HOME" ]] && [[ $- == *i* ]]; then
1205 cd /a
1206 fi
1207
1208
1209 # best practice
1210 unset IFS
1211
1212
1213 # for mitmproxy to get a newer python.
1214 # commented until i want to use it because it
1215 # noticably slows bash startup
1216 #
1217
1218 mypyenvinit () {
1219 if [[ $EUID == 0 || ! -e ~/.pyenv/bin ]]; then
1220 echo "error: dont be root. make sure pyenv is installed"
1221 return 1
1222 fi
1223 export PATH="$HOME/.pyenv/bin:$PATH"
1224 eval "$(pyenv init -)"
1225 eval "$(pyenv virtualenv-init -)"
1226 }
1227
1228
1229 export GOPATH=$HOME/go
1230 path-add $GOPATH/bin
1231 path-add /usr/local/go/bin
1232
1233 # I have the git repo and a release. either one should work.
1234 # I have both because I was trying to solve an issue that
1235 # turned out to be unrelated.
1236 # ARDUINO_PATH=/a/opt/Arduino/build/linux/work
1237 export ARDUINO_PATH=/a/opt/arduino-1.8.9
1238
1239 # They want to be added to the start, but i think
1240 # that should be avoided unless we really need it.
1241 path-add --end ~/.npm-global
1242
1243 path-add --end $HOME/.cargo/bin
1244
1245 # taken from default changes to bashrc and bash_profile
1246 path-add --end $HOME/.rvm/bin
1247 path-add --end $HOME/.gem/ruby/2.3.0/bin
1248
1249
1250 export BASEFILE_DIR=/a/bin/fai-basefiles
1251
1252 #export ANDROID_HOME=/a/opt/android-home
1253 # https://f-droid.org/en/docs/Installing_the_Server_and_Repo_Tools/
1254 #export USE_SDK_WRAPPER=yes
1255 #PATH=$PATH:$ANDROID_HOME/tools:$ANDROID_HOME/platform-tools
1256
1257 # didnt get drush working, if I did, this seems like the
1258 # only good thing to include for it.
1259 # Include Drush completion.
1260 # if [ -f "/home/ian/.drush/drush.complete.sh" ] ; then
1261 # source /home/ian/.drush/drush.complete.sh
1262 # fi
1263
1264
1265 # https://wiki.archlinux.org/index.php/Xinitrc#Autostart_X_at_login
1266 # i added an extra condition as gentoo xorg guide says depending on
1267 # $DISPLAY is fragile.
1268 if [[ ! $DISPLAY && $XDG_VTNR == 1 ]] && shopt -q login_shell && isarch; then
1269 exec startx
1270 fi
1271
1272
1273 # ensure no bad programs appending to this file will have an affect
1274 return 0